unit BWColProp;
{
  Copyright (c) 1998 by Bugsy Wabbit.
  Author: Bugsy Wabbit
}

interface

 uses
  DsgnIntf,
  frmColorsProp,
  BWEdits;

type
  ColorListEditor = class( TPropertyEditor )
    procedure Edit; override;
    function GetAttributes : TPropertyAttributes; override;
    function GetValue : string; override;
    procedure SetValue( const Value : string ); override;
  end;

procedure Register;

implementation

procedure ColorListEditor.Edit;
{ Called when the '...' button is pressed or the property is double-clicked. }
begin
  { To call the inherited implementation, use "inherited Edit;" }
  { CDK: Place your overriding code here. }
  with TfrmColorsEdit.Create( Application ) do
  begin
    try
      { Set dialog's caption. }
      Caption := GetComponent( 0 ).Owner.Name + '.' + GetComponent( 0 ).Name + ' - ' + Caption;

      with GetComponent( 0 ) as TBWEdit do
      begin
        { CDK: Transfer properties from the component on the form to your component editor dialog (if needed). For example, use "BWEditPreview.Colors := TBWHashList( GetOrdValue );" }
      end;  { with }
      
      if ShowModal = mrOK then
      begin
        with GetComponent( 0 ) as TBWEdit do
        begin
          { CDK: Transfer properties from your component editor dialog back to the component on the form (if needed). For example, use "SetOrdValue( longint( BWEditPreview.Colors ) );" }
        end;  { with }
      end;  { if }
    finally
      Free;  { Free dialog. }
    end;  { try/finally }
  end;  { with }
end;  { Edit }

function ColorListEditor.GetAttributes : TPropertyAttributes;
{ Returns information used by the Object Inspector to show the approprate adornments (e.g., "..." button, drop-down button). }
begin
  GetAttributes := [paDialog];
end;  { GetAttributes }

function ColorListEditor.GetValue : string;
{ Returns a string representation for the property's current value, so that the Object Inspector can display it. The default is "unknown". }
begin
  { CDK: Replace following call to inherited GetValue with your own string representation of the current value of the property being edited. }
  result := inherited GetValue;
end;  { GetValue }

procedure ColorListEditor.SetValue( const Value : string );
{ Called to set the value of the property.  }
begin
  { CDK: If Value is not in the correct format or is an illegal value, you should raise an exception describing the problem. Example: }
  { if (Value is illegal) then }
  {   raise EPropertyError.CreateFmt( 'Invalid value for property %s.', [GetName] ); }
  { CDK: Confirm that following code converts Value appropriately, or optionally you can ignore all changes and force users to edit the property via an Edit method override. }
  SetOrdValue( TBWHashList( GetOrdValue ) );
end;  { SetValue }

procedure Register;
begin
  RegisterPropertyEditor( TypeInfo( TBWHashList ), TBWEdit, 'Colors', ColorListEditor );
end;  { Register }

end.

